profunctors-5.3: Profunctors

Copyright | (C) 2011-2015 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | provisional
Portability | portable
Safe Haskell | Trustworthy
Language | Haskell2010

Data.Profunctor.Types

Description

For a good explanation of profunctors in Haskell see Dan Piponi's article:

http://blog.sigfpe.com/2011/07/profunctors-in-haskell.html

For more information on strength and costrength, see:

http://comonad.com/reader/2008/deriving-strength-from-laziness/

Synopsis

- class Profunctor p where
  - dimap :: (a -> b) -> (c -> d) -> p b c -> p a d
  - lmap :: (a -> b) -> p b c -> p a c
  - rmap :: (b -> c) -> p a b -> p a c
- newtype Star f d c = Star {
  - runStar :: d -> f c
  }
- newtype Costar f d c = Costar {
  - runCostar :: f d -> c
  }
- newtype WrappedArrow p a b = WrapArrow {
  - unwrapArrow :: p a b
  }
- newtype Forget r a b = Forget {
  - runForget :: a -> r
  }
- type (:->) p q = forall a b. p a b -> q a b

# Documentation

class Profunctor p where Source #

Formally, the class `Profunctor` represents a profunctor from `Hask` -> `Hask`.

Intuitively it is a bifunctor where the first argument is contravariant and the second argument is covariant.

You can define a `Profunctor` by either defining `dimap` or by defining both `lmap` and `rmap`.

If you supply `dimap`, you should ensure that:

    dimap id id ≡ id

If you supply `lmap` and `rmap`, ensure:

    lmap id ≡ id
    rmap id ≡ id

If you supply both, you should also ensure:

    dimap f g ≡ lmap f . rmap g

These ensure by parametricity:

    dimap (f . g) (h . i) ≡ dimap g h . dimap f i
    lmap (f . g) ≡ lmap g . lmap f
    rmap (f . g) ≡ rmap f . rmap g

Minimal complete definition

dimap | lmap, rmap

Methods

dimap :: (a -> b) -> (c -> d) -> p b c -> p a d Source #

Map over both arguments at the same time.

    dimap f g ≡ lmap f . rmap g

lmap :: (a -> b) -> p b c -> p a c Source #

Map the first argument contravariantly.

    lmap f ≡ dimap f id

rmap :: (b -> c) -> p a b -> p a c Source #

Map the second argument covariantly.

    rmap ≡ dimap id

Instances

Monad m => Profunctor (Kleisli m) Source # |
Instance details Defined in Data.Profunctor.Unsafe Methods dimap :: (a -> b) -> (c -> d) -> Kleisli m b c -> Kleisli m a d Source # lmap :: (a -> b) -> Kleisli m b c -> Kleisli m a c Source # rmap :: (b -> c) -> Kleisli m a b -> Kleisli m a c Source # (#.) :: Coercible c b => q b c -> Kleisli m a b -> Kleisli m a c Source # (.#) :: Coercible b a => Kleisli m b c -> q a b -> Kleisli m a c Source #
Profunctor (Tagged :: Type -> Type -> Type) Source # |
Instance details Defined in Data.Profunctor.Unsafe Methods dimap :: (a -> b) -> (c -> d) -> Tagged b c -> Tagged a d Source # lmap :: (a -> b) -> Tagged b c -> Tagged a c Source # rmap :: (b -> c) -> Tagged a b -> Tagged a c Source # (#.) :: Coercible c b => q b c -> Tagged a b -> Tagged a c Source # (.#) :: Coercible b a => Tagged b c -> q a b -> Tagged a c Source #
Profunctor (Forget r) Source # |
Instance details Defined in Data.Profunctor.Types Methods dimap :: (a -> b) -> (c -> d) -> Forget r b c -> Forget r a d Source # lmap :: (a -> b) -> Forget r b c -> Forget r a c Source # rmap :: (b -> c) -> Forget r a b -> Forget r a c Source # (#.) :: Coercible c b => q b c -> Forget r a b -> Forget r a c Source # (.#) :: Coercible b a => Forget r b c -> q a b -> Forget r a c Source #
Arrow p => Profunctor (WrappedArrow p) Source # |

Instance details

Defined in Data.Profunctor.Types

Methods

dimap :: (a -> b) -> (c -> d) -> WrappedArrow p b c -> WrappedArrow p a d Source #

lmap :: (a -> b) -> WrappedArrow p b c -> WrappedArrow p a c Source #

rmap :: (b -> c) -> WrappedArrow p a b -> WrappedArrow p a c Source #

(#.) :: Coercible c b => q b c -> WrappedArrow p a b -> WrappedArrow p a c Source #

(.#) :: Coercible b a => WrappedArrow p b c -> q a b -> WrappedArrow p a c Source #

Functor f => Profunctor (Costar f) Source # |
Instance details Defined in Data.Profunctor.Types Methods dimap :: (a -> b) -> (c -> d) -> Costar f b c -> Costar f a d Source # lmap :: (a -> b) -> Costar f b c -> Costar f a c Source # rmap :: (b -> c) -> Costar f a b -> Costar f a c Source # (#.) :: Coercible c b => q b c -> Costar f a b -> Costar f a c Source # (.#) :: Coercible b a => Costar f b c -> q a b -> Costar f a c Source #
Functor f => Profunctor (Star f) Source # |
Instance details Defined in Data.Profunctor.Types Methods dimap :: (a -> b) -> (c -> d) -> Star f b c -> Star f a d Source # lmap :: (a -> b) -> Star f b c -> Star f a c Source # rmap :: (b -> c) -> Star f a b -> Star f a c Source # (#.) :: Coercible c b => q b c -> Star f a b -> Star f a c Source # (.#) :: Coercible b a => Star f b c -> q a b -> Star f a c Source #
Profunctor (Copastro p) Source # |

Instance details

Defined in Data.Profunctor.Strong

Methods

dimap :: (a -> b) -> (c -> d) -> Copastro p b c -> Copastro p a d Source #

lmap :: (a -> b) -> Copastro p b c -> Copastro p a c Source #

rmap :: (b -> c) -> Copastro p a b -> Copastro p a c Source #

(#.) :: Coercible c b => q b c -> Copastro p a b -> Copastro p a c Source #

(.#) :: Coercible b a => Copastro p b c -> q a b -> Copastro p a c Source #

Profunctor (Cotambara p) Source # |

Instance details

Defined in Data.Profunctor.Strong

Methods

dimap :: (a -> b) -> (c -> d) -> Cotambara p b c -> Cotambara p a d Source #

lmap :: (a -> b) -> Cotambara p b c -> Cotambara p a c Source #

rmap :: (b -> c) -> Cotambara p a b -> Cotambara p a c Source #

(#.) :: Coercible c b => q b c -> Cotambara p a b -> Cotambara p a c Source #

(.#) :: Coercible b a => Cotambara p b c -> q a b -> Cotambara p a c Source #

Profunctor (Pastro p) Source # |
Instance details Defined in Data.Profunctor.Strong Methods dimap :: (a -> b) -> (c -> d) -> Pastro p b c -> Pastro p a d Source # lmap :: (a -> b) -> Pastro p b c -> Pastro p a c Source # rmap :: (b -> c) -> Pastro p a b -> Pastro p a c Source # (#.) :: Coercible c b => q b c -> Pastro p a b -> Pastro p a c Source # (.#) :: Coercible b a => Pastro p b c -> q a b -> Pastro p a c Source #
Profunctor p => Profunctor (Tambara p) Source # |
Instance details Defined in Data.Profunctor.Strong Methods dimap :: (a -> b) -> (c -> d) -> Tambara p b c -> Tambara p a d Source # lmap :: (a -> b) -> Tambara p b c -> Tambara p a c Source # rmap :: (b -> c) -> Tambara p a b -> Tambara p a c Source # (#.) :: Coercible c b => q b c -> Tambara p a b -> Tambara p a c Source # (.#) :: Coercible b a => Tambara p b c -> q a b -> Tambara p a c Source #
Profunctor (Environment p) Source # |

Instance details

Defined in Data.Profunctor.Closed

Methods

dimap :: (a -> b) -> (c -> d) -> Environment p b c -> Environment p a d Source #

lmap :: (a -> b) -> Environment p b c -> Environment p a c Source #

rmap :: (b -> c) -> Environment p a b -> Environment p a c Source #

(#.) :: Coercible c b => q b c -> Environment p a b -> Environment p a c Source #

(.#) :: Coercible b a => Environment p b c -> q a b -> Environment p a c Source #

Profunctor p => Profunctor (Closure p) Source # |
Instance details Defined in Data.Profunctor.Closed Methods dimap :: (a -> b) -> (c -> d) -> Closure p b c -> Closure p a d Source # lmap :: (a -> b) -> Closure p b c -> Closure p a c Source # rmap :: (b -> c) -> Closure p a b -> Closure p a c Source # (#.) :: Coercible c b => q b c -> Closure p a b -> Closure p a c Source # (.#) :: Coercible b a => Closure p b c -> q a b -> Closure p a c Source #
Profunctor (CopastroSum p) Source # |

Instance details

Defined in Data.Profunctor.Choice

Methods

dimap :: (a -> b) -> (c -> d) -> CopastroSum p b c -> CopastroSum p a d Source #

lmap :: (a -> b) -> CopastroSum p b c -> CopastroSum p a c Source #

rmap :: (b -> c) -> CopastroSum p a b -> CopastroSum p a c Source #

(#.) :: Coercible c b => q b c -> CopastroSum p a b -> CopastroSum p a c Source #

(.#) :: Coercible b a => CopastroSum p b c -> q a b -> CopastroSum p a c Source #

Profunctor (CotambaraSum p) Source # |

Instance details

Defined in Data.Profunctor.Choice

Methods

dimap :: (a -> b) -> (c -> d) -> CotambaraSum p b c -> CotambaraSum p a d Source #

lmap :: (a -> b) -> CotambaraSum p b c -> CotambaraSum p a c Source #

rmap :: (b -> c) -> CotambaraSum p a b -> CotambaraSum p a c Source #

(#.) :: Coercible c b => q b c -> CotambaraSum p a b -> CotambaraSum p a c Source #

(.#) :: Coercible b a => CotambaraSum p b c -> q a b -> CotambaraSum p a c Source #

Profunctor (PastroSum p) Source # |

Instance details

Defined in Data.Profunctor.Choice

Methods

dimap :: (a -> b) -> (c -> d) -> PastroSum p b c -> PastroSum p a d Source #

lmap :: (a -> b) -> PastroSum p b c -> PastroSum p a c Source #

rmap :: (b -> c) -> PastroSum p a b -> PastroSum p a c Source #

(#.) :: Coercible c b => q b c -> PastroSum p a b -> PastroSum p a c Source #

(.#) :: Coercible b a => PastroSum p b c -> q a b -> PastroSum p a c Source #

Profunctor p => Profunctor (TambaraSum p) Source # |

Instance details

Defined in Data.Profunctor.Choice

Methods

dimap :: (a -> b) -> (c -> d) -> TambaraSum p b c -> TambaraSum p a d Source #

lmap :: (a -> b) -> TambaraSum p b c -> TambaraSum p a c Source #

rmap :: (b -> c) -> TambaraSum p a b -> TambaraSum p a c Source #

(#.) :: Coercible c b => q b c -> TambaraSum p a b -> TambaraSum p a c Source #

(.#) :: Coercible b a => TambaraSum p b c -> q a b -> TambaraSum p a c Source #

Profunctor (FreeTraversing p) Source # |

Instance details

Defined in Data.Profunctor.Traversing

Methods

dimap :: (a -> b) -> (c -> d) -> FreeTraversing p b c -> FreeTraversing p a d Source #

lmap :: (a -> b) -> FreeTraversing p b c -> FreeTraversing p a c Source #

rmap :: (b -> c) -> FreeTraversing p a b -> FreeTraversing p a c Source #

(#.) :: Coercible c b => q b c -> FreeTraversing p a b -> FreeTraversing p a c Source #

(.#) :: Coercible b a => FreeTraversing p b c -> q a b -> FreeTraversing p a c Source #

Profunctor p => Profunctor (CofreeTraversing p) Source # |

Instance details

Defined in Data.Profunctor.Traversing

Methods

dimap :: (a -> b) -> (c -> d) -> CofreeTraversing p b c -> CofreeTraversing p a d Source #

lmap :: (a -> b) -> CofreeTraversing p b c -> CofreeTraversing p a c Source #

rmap :: (b -> c) -> CofreeTraversing p a b -> CofreeTraversing p a c Source #

(#.) :: Coercible c b => q b c -> CofreeTraversing p a b -> CofreeTraversing p a c Source #

(.#) :: Coercible b a => CofreeTraversing p b c -> q a b -> CofreeTraversing p a c Source #

Profunctor (FreeMapping p) Source # |

Instance details

Defined in Data.Profunctor.Mapping

Methods

dimap :: (a -> b) -> (c -> d) -> FreeMapping p b c -> FreeMapping p a d Source #

lmap :: (a -> b) -> FreeMapping p b c -> FreeMapping p a c Source #

rmap :: (b -> c) -> FreeMapping p a b -> FreeMapping p a c Source #

(#.) :: Coercible c b => q b c -> FreeMapping p a b -> FreeMapping p a c Source #

(.#) :: Coercible b a => FreeMapping p b c -> q a b -> FreeMapping p a c Source #

Profunctor p => Profunctor (CofreeMapping p) Source # |

Instance details

Defined in Data.Profunctor.Mapping

Methods

dimap :: (a -> b) -> (c -> d) -> CofreeMapping p b c -> CofreeMapping p a d Source #

lmap :: (a -> b) -> CofreeMapping p b c -> CofreeMapping p a c Source #

rmap :: (b -> c) -> CofreeMapping p a b -> CofreeMapping p a c Source #

(#.) :: Coercible c b => q b c -> CofreeMapping p a b -> CofreeMapping p a c Source #

(.#) :: Coercible b a => CofreeMapping p b c -> q a b -> CofreeMapping p a c Source #

Profunctor p => Profunctor (Codensity p) Source # |

Instance details

Defined in Data.Profunctor.Ran

Methods

dimap :: (a -> b) -> (c -> d) -> Codensity p b c -> Codensity p a d Source #

lmap :: (a -> b) -> Codensity p b c -> Codensity p a c Source #

rmap :: (b -> c) -> Codensity p a b -> Codensity p a c Source #

(#.) :: Coercible c b => q b c -> Codensity p a b -> Codensity p a c Source #

(.#) :: Coercible b a => Codensity p b c -> q a b -> Codensity p a c Source #

Profunctor (Coyoneda p) Source # |

Instance details

Defined in Data.Profunctor.Yoneda

Methods

dimap :: (a -> b) -> (c -> d) -> Coyoneda p b c -> Coyoneda p a d Source #

lmap :: (a -> b) -> Coyoneda p b c -> Coyoneda p a c Source #

rmap :: (b -> c) -> Coyoneda p a b -> Coyoneda p a c Source #

(#.) :: Coercible c b => q b c -> Coyoneda p a b -> Coyoneda p a c Source #

(.#) :: Coercible b a => Coyoneda p b c -> q a b -> Coyoneda p a c Source #

Profunctor (Yoneda p) Source # |
Instance details Defined in Data.Profunctor.Yoneda Methods dimap :: (a -> b) -> (c -> d) -> Yoneda p b c -> Yoneda p a d Source # lmap :: (a -> b) -> Yoneda p b c -> Yoneda p a c Source # rmap :: (b -> c) -> Yoneda p a b -> Yoneda p a c Source # (#.) :: Coercible c b => q b c -> Yoneda p a b -> Yoneda p a c Source # (.#) :: Coercible b a => Yoneda p b c -> q a b -> Yoneda p a c Source #
Profunctor ((->) :: Type -> Type -> Type) Source # |
Instance details Defined in Data.Profunctor.Unsafe Methods dimap :: (a -> b) -> (c -> d) -> (b -> c) -> a -> d Source # lmap :: (a -> b) -> (b -> c) -> a -> c Source # rmap :: (b -> c) -> (a -> b) -> a -> c Source # (#.) :: Coercible c b => q b c -> (a -> b) -> a -> c Source # (.#) :: Coercible b a => (b -> c) -> q a b -> a -> c Source #
Functor w => Profunctor (Cokleisli w) Source # |

Instance details

Defined in Data.Profunctor.Unsafe

Methods

dimap :: (a -> b) -> (c -> d) -> Cokleisli w b c -> Cokleisli w a d Source #

lmap :: (a -> b) -> Cokleisli w b c -> Cokleisli w a c Source #

rmap :: (b -> c) -> Cokleisli w a b -> Cokleisli w a c Source #

(#.) :: Coercible c b => q b c -> Cokleisli w a b -> Cokleisli w a c Source #

(.#) :: Coercible b a => Cokleisli w b c -> q a b -> Cokleisli w a c Source #

(Profunctor p, Profunctor q) => Profunctor (Rift p q) Source # |
Instance details Defined in Data.Profunctor.Composition Methods dimap :: (a -> b) -> (c -> d) -> Rift p q b c -> Rift p q a d Source # lmap :: (a -> b) -> Rift p q b c -> Rift p q a c Source # rmap :: (b -> c) -> Rift p q a b -> Rift p q a c Source # (#.) :: Coercible c b => q0 b c -> Rift p q a b -> Rift p q a c Source # (.#) :: Coercible b a => Rift p q b c -> q0 a b -> Rift p q a c Source #
(Profunctor p, Profunctor q) => Profunctor (Procompose p q) Source # |

Instance details

Defined in Data.Profunctor.Composition

Methods

dimap :: (a -> b) -> (c -> d) -> Procompose p q b c -> Procompose p q a d Source #

lmap :: (a -> b) -> Procompose p q b c -> Procompose p q a c Source #

rmap :: (b -> c) -> Procompose p q a b -> Procompose p q a c Source #

(#.) :: Coercible c b => q0 b c -> Procompose p q a b -> Procompose p q a c Source #

(.#) :: Coercible b a => Procompose p q b c -> q0 a b -> Procompose p q a c Source #

(Profunctor p, Profunctor q) => Profunctor (Ran p q) Source # |
Instance details Defined in Data.Profunctor.Ran Methods dimap :: (a -> b) -> (c -> d) -> Ran p q b c -> Ran p q a d Source # lmap :: (a -> b) -> Ran p q b c -> Ran p q a c Source # rmap :: (b -> c) -> Ran p q a b -> Ran p q a c Source # (#.) :: Coercible c b => q0 b c -> Ran p q a b -> Ran p q a c Source # (.#) :: Coercible b a => Ran p q b c -> q0 a b -> Ran p q a c Source #
(Functor f, Profunctor p) => Profunctor (Cayley f p) Source # |

Instance details

Defined in Data.Profunctor.Cayley

Methods

dimap :: (a -> b) -> (c -> d) -> Cayley f p b c -> Cayley f p a d Source #

lmap :: (a -> b) -> Cayley f p b c -> Cayley f p a c Source #

rmap :: (b -> c) -> Cayley f p a b -> Cayley f p a c Source #

(#.) :: Coercible c b => q b c -> Cayley f p a b -> Cayley f p a c Source #

(.#) :: Coercible b a => Cayley f p b c -> q a b -> Cayley f p a c Source #

Functor f => Profunctor (Joker f :: Type -> Type -> Type) Source # |
Instance details Defined in Data.Profunctor.Unsafe Methods dimap :: (a -> b) -> (c -> d) -> Joker f b c -> Joker f a d Source # lmap :: (a -> b) -> Joker f b c -> Joker f a c Source # rmap :: (b -> c) -> Joker f a b -> Joker f a c Source # (#.) :: Coercible c b => q b c -> Joker f a b -> Joker f a c Source # (.#) :: Coercible b a => Joker f b c -> q a b -> Joker f a c Source #
Contravariant f => Profunctor (Clown f :: Type -> Type -> Type) Source # |
Instance details Defined in Data.Profunctor.Unsafe Methods dimap :: (a -> b) -> (c -> d) -> Clown f b c -> Clown f a d Source # lmap :: (a -> b) -> Clown f b c -> Clown f a c Source # rmap :: (b -> c) -> Clown f a b -> Clown f a c Source # (#.) :: Coercible c b => q b c -> Clown f a b -> Clown f a c Source # (.#) :: Coercible b a => Clown f b c -> q a b -> Clown f a c Source #
(Profunctor p, Profunctor q) => Profunctor (Sum p q) Source # |
Instance details Defined in Data.Profunctor.Unsafe Methods dimap :: (a -> b) -> (c -> d) -> Sum p q b c -> Sum p q a d Source # lmap :: (a -> b) -> Sum p q b c -> Sum p q a c Source # rmap :: (b -> c) -> Sum p q a b -> Sum p q a c Source # (#.) :: Coercible c b => q0 b c -> Sum p q a b -> Sum p q a c Source # (.#) :: Coercible b a => Sum p q b c -> q0 a b -> Sum p q a c Source #
(Profunctor p, Profunctor q) => Profunctor (Product p q) Source # |

Instance details

Defined in Data.Profunctor.Unsafe

Methods

dimap :: (a -> b) -> (c -> d) -> Product p q b c -> Product p q a d Source #

lmap :: (a -> b) -> Product p q b c -> Product p q a c Source #

rmap :: (b -> c) -> Product p q a b -> Product p q a c Source #

(#.) :: Coercible c b => q0 b c -> Product p q a b -> Product p q a c Source #

(.#) :: Coercible b a => Product p q b c -> q0 a b -> Product p q a c Source #

(Functor f, Profunctor p) => Profunctor (Tannen f p) Source # |

Instance details

Defined in Data.Profunctor.Unsafe

Methods

dimap :: (a -> b) -> (c -> d) -> Tannen f p b c -> Tannen f p a d Source #

lmap :: (a -> b) -> Tannen f p b c -> Tannen f p a c Source #

rmap :: (b -> c) -> Tannen f p a b -> Tannen f p a c Source #

(#.) :: Coercible c b => q b c -> Tannen f p a b -> Tannen f p a c Source #

(.#) :: Coercible b a => Tannen f p b c -> q a b -> Tannen f p a c Source #

(Profunctor p, Functor f, Functor g) => Profunctor (Biff p f g) Source # |

Instance details

Defined in Data.Profunctor.Unsafe

Methods

dimap :: (a -> b) -> (c -> d) -> Biff p f g b c -> Biff p f g a d Source #

lmap :: (a -> b) -> Biff p f g b c -> Biff p f g a c Source #

rmap :: (b -> c) -> Biff p f g a b -> Biff p f g a c Source #

(#.) :: Coercible c b => q b c -> Biff p f g a b -> Biff p f g a c Source #

(.#) :: Coercible b a => Biff p f g b c -> q a b -> Biff p f g a c Source #

newtype Star f d c Source #

Lift a `Functor` into a `Profunctor` (forwards).

Constructors

Star |

Fields

- runStar :: d -> f c

Instances

Functor f => Profunctor (Star f) Source # |
Instance details Defined in Data.Profunctor.Types Methods dimap :: (a -> b) -> (c -> d) -> Star f b c -> Star f a d Source # lmap :: (a -> b) -> Star f b c -> Star f a c Source # rmap :: (b -> c) -> Star f a b -> Star f a c Source # (#.) :: Coercible c b => q b c -> Star f a b -> Star f a c Source # (.#) :: Coercible b a => Star f b c -> q a b -> Star f a c Source #
Functor m => Strong (Star m) Source # |
Instance details Defined in Data.Profunctor.Strong Methods first' :: Star m a b -> Star m (a, c) (b, c) Source # second' :: Star m a b -> Star m (c, a) (c, b) Source #
Distributive f => Closed (Star f) Source # |
Instance details Defined in Data.Profunctor.Closed Methods closed :: Star f a b -> Star f (x -> a) (x -> b) Source #
Traversable f => Cochoice (Star f) Source # |
Instance details Defined in Data.Profunctor.Choice Methods unleft :: Star f (Either a d) (Either b d) -> Star f a b Source # unright :: Star f (Either d a) (Either d b) -> Star f a b Source #
Applicative f => Choice (Star f) Source # |
Instance details Defined in Data.Profunctor.Choice Methods left' :: Star f a b -> Star f (Either a c) (Either b c) Source # right' :: Star f a b -> Star f (Either c a) (Either c b) Source #
Applicative m => Traversing (Star m) Source # |
Instance details Defined in Data.Profunctor.Traversing Methods traverse' :: Traversable f => Star m a b -> Star m (f a) (f b) Source # wander :: (forall (f :: Type -> Type). Applicative f => (a -> f b) -> s -> f t) -> Star m a b -> Star m s t Source #
(Applicative m, Distributive m) => Mapping (Star m) Source # |
Instance details Defined in Data.Profunctor.Mapping Methods map' :: Functor f => Star m a b -> Star m (f a) (f b) Source #
Functor f => Representable (Star f) Source # |
Instance details Defined in Data.Profunctor.Rep Associated Types type Rep (Star f) :: Type -> Type Source # Methods tabulate :: (d -> Rep (Star f) c) -> Star f d c Source #
Functor f => Sieve (Star f) f Source # |
Instance details Defined in Data.Profunctor.Sieve Methods sieve :: Star f a b -> a -> f b Source #
Monad f => Category (Star f :: Type -> Type -> Type) Source # |
Instance details Defined in Data.Profunctor.Types Methods id :: Star f a a Source # (.) :: Star f b c -> Star f a b -> Star f a c Source #
Monad f => Monad (Star f a) Source # |
Instance details Defined in Data.Profunctor.Types Methods (>>=) :: Star f a a0 -> (a0 -> Star f a b) -> Star f a b Source # (>>) :: Star f a a0 -> Star f a b -> Star f a b Source # return :: a0 -> Star f a a0 Source # fail :: String -> Star f a a0 Source #
Functor f => Functor (Star f a) Source # |
Instance details Defined in Data.Profunctor.Types Methods fmap :: (a0 -> b) -> Star f a a0 -> Star f a b Source # (<$) :: a0 -> Star f a b -> Star f a a0 Source #
Applicative f => Applicative (Star f a) Source # |
Instance details Defined in Data.Profunctor.Types Methods pure :: a0 -> Star f a a0 Source # (<*>) :: Star f a (a0 -> b) -> Star f a a0 -> Star f a b Source # liftA2 :: (a0 -> b -> c) -> Star f a a0 -> Star f a b -> Star f a c Source # (*>) :: Star f a a0 -> Star f a b -> Star f a b Source # (<*) :: Star f a a0 -> Star f a b -> Star f a a0 Source #
Alternative f => Alternative (Star f a) Source # |
Instance details Defined in Data.Profunctor.Types Methods empty :: Star f a a0 Source # (<|>) :: Star f a a0 -> Star f a a0 -> Star f a a0 Source # some :: Star f a a0 -> Star f a [a0] Source # many :: Star f a a0 -> Star f a [a0] Source #
MonadPlus f => MonadPlus (Star f a) Source # |
Instance details Defined in Data.Profunctor.Types Methods mzero :: Star f a a0 Source # mplus :: Star f a a0 -> Star f a a0 -> Star f a a0 Source #
Distributive f => Distributive (Star f a) Source # |
Instance details Defined in Data.Profunctor.Types Methods distribute :: Functor f0 => f0 (Star f a a0) -> Star f a (f0 a0) Source # collect :: Functor f0 => (a0 -> Star f a b) -> f0 a0 -> Star f a (f0 b) Source # distributeM :: Monad m => m (Star f a a0) -> Star f a (m a0) Source # collectM :: Monad m => (a0 -> Star f a b) -> m a0 -> Star f a (m b) Source #
type Rep (Star f) Source # |
Instance details Defined in Data.Profunctor.Rep type Rep (Star f) = f

newtype Costar f d c Source #

Lift a `Functor` into a `Profunctor` (backwards).

Constructors

Costar |

Fields

- runCostar :: f d -> c

Instances

Functor f => Profunctor (Costar f) Source # |
Instance details Defined in Data.Profunctor.Types Methods dimap :: (a -> b) -> (c -> d) -> Costar f b c -> Costar f a d Source # lmap :: (a -> b) -> Costar f b c -> Costar f a c Source # rmap :: (b -> c) -> Costar f a b -> Costar f a c Source # (#.) :: Coercible c b => q b c -> Costar f a b -> Costar f a c Source # (.#) :: Coercible b a => Costar f b c -> q a b -> Costar f a c Source #
Functor f => Costrong (Costar f) Source # |
Instance details Defined in Data.Profunctor.Strong Methods unfirst :: Costar f (a, d) (b, d) -> Costar f a b Source # unsecond :: Costar f (d, a) (d, b) -> Costar f a b Source #
Functor f => Closed (Costar f) Source # |
Instance details Defined in Data.Profunctor.Closed Methods closed :: Costar f a b -> Costar f (x -> a) (x -> b) Source #
Applicative f => Cochoice (Costar f) Source # |
Instance details Defined in Data.Profunctor.Choice Methods unleft :: Costar f (Either a d) (Either b d) -> Costar f a b Source # unright :: Costar f (Either d a) (Either d b) -> Costar f a b Source #
Traversable w => Choice (Costar w) Source # |
Instance details Defined in Data.Profunctor.Choice Methods left' :: Costar w a b -> Costar w (Either a c) (Either b c) Source # right' :: Costar w a b -> Costar w (Either c a) (Either c b) Source #
Functor f => Corepresentable (Costar f) Source # |
Instance details Defined in Data.Profunctor.Rep Associated Types type Corep (Costar f) :: Type -> Type Source # Methods cotabulate :: (Corep (Costar f) d -> c) -> Costar f d c Source #
Functor f => Cosieve (Costar f) f Source # |
Instance details Defined in Data.Profunctor.Sieve Methods cosieve :: Costar f a b -> f a -> b Source #
Monad (Costar f a) Source # |
Instance details Defined in Data.Profunctor.Types Methods (>>=) :: Costar f a a0 -> (a0 -> Costar f a b) -> Costar f a b Source # (>>) :: Costar f a a0 -> Costar f a b -> Costar f a b Source # return :: a0 -> Costar f a a0 Source # fail :: String -> Costar f a a0 Source #
Functor (Costar f a) Source # |
Instance details Defined in Data.Profunctor.Types Methods fmap :: (a0 -> b) -> Costar f a a0 -> Costar f a b Source # (<$) :: a0 -> Costar f a b -> Costar f a a0 Source #
Applicative (Costar f a) Source # |
Instance details Defined in Data.Profunctor.Types Methods pure :: a0 -> Costar f a a0 Source # (<*>) :: Costar f a (a0 -> b) -> Costar f a a0 -> Costar f a b Source # liftA2 :: (a0 -> b -> c) -> Costar f a a0 -> Costar f a b -> Costar f a c Source # (*>) :: Costar f a a0 -> Costar f a b -> Costar f a b Source # (<*) :: Costar f a a0 -> Costar f a b -> Costar f a a0 Source #
Distributive (Costar f d) Source # |
Instance details Defined in Data.Profunctor.Types Methods distribute :: Functor f0 => f0 (Costar f d a) -> Costar f d (f0 a) Source # collect :: Functor f0 => (a -> Costar f d b) -> f0 a -> Costar f d (f0 b) Source # distributeM :: Monad m => m (Costar f d a) -> Costar f d (m a) Source # collectM :: Monad m => (a -> Costar f d b) -> m a -> Costar f d (m b) Source #
type Corep (Costar f) Source # |
Instance details Defined in Data.Profunctor.Rep type Corep (Costar f) = f

newtype WrappedArrow p a b Source #

Wrap an arrow for use as a `Profunctor`.

Constructors

WrapArrow |

Fields

- unwrapArrow :: p a b

Instances

Arrow p => Arrow (WrappedArrow p) Source # |

Instance details

Defined in Data.Profunctor.Types

Methods

arr :: (b -> c) -> WrappedArrow p b c Source #

first :: WrappedArrow p b c -> WrappedArrow p (b, d) (c, d) Source #

second :: WrappedArrow p b c -> WrappedArrow p (d, b) (d, c) Source #

(***) :: WrappedArrow p b c -> WrappedArrow p b' c' -> WrappedArrow p (b, b') (c, c') Source #

(&&&) :: WrappedArrow p b c -> WrappedArrow p b c' -> WrappedArrow p b (c, c') Source #

ArrowZero p => ArrowZero (WrappedArrow p) Source # |
Instance details Defined in Data.Profunctor.Types Methods zeroArrow :: WrappedArrow p b c Source #
ArrowChoice p => ArrowChoice (WrappedArrow p) Source # |

Instance details

Defined in Data.Profunctor.Types

Methods

left :: WrappedArrow p b c -> WrappedArrow p (Either b d) (Either c d) Source #

right :: WrappedArrow p b c -> WrappedArrow p (Either d b) (Either d c) Source #

(+++) :: WrappedArrow p b c -> WrappedArrow p b' c' -> WrappedArrow p (Either b b') (Either c c') Source #

(|||) :: WrappedArrow p b d -> WrappedArrow p c d -> WrappedArrow p (Either b c) d Source #

ArrowApply p => ArrowApply (WrappedArrow p) Source # |
Instance details Defined in Data.Profunctor.Types Methods app :: WrappedArrow p (WrappedArrow p b c, b) c Source #
ArrowLoop p => ArrowLoop (WrappedArrow p) Source # |
Instance details Defined in Data.Profunctor.Types Methods loop :: WrappedArrow p (b, d) (c, d) -> WrappedArrow p b c Source #
Arrow p => Profunctor (WrappedArrow p) Source # |

Instance details

Defined in Data.Profunctor.Types

Methods

dimap :: (a -> b) -> (c -> d) -> WrappedArrow p b c -> WrappedArrow p a d Source #

lmap :: (a -> b) -> WrappedArrow p b c -> WrappedArrow p a c Source #

rmap :: (b -> c) -> WrappedArrow p a b -> WrappedArrow p a c Source #

(#.) :: Coercible c b => q b c -> WrappedArrow p a b -> WrappedArrow p a c Source #

(.#) :: Coercible b a => WrappedArrow p b c -> q a b -> WrappedArrow p a c Source #

ArrowLoop p => Costrong (WrappedArrow p) Source # |
Instance details Defined in Data.Profunctor.Strong Methods unfirst :: WrappedArrow p (a, d) (b, d) -> WrappedArrow p a b Source # unsecond :: WrappedArrow p (d, a) (d, b) -> WrappedArrow p a b Source #
Arrow p => Strong (WrappedArrow p) Source # | `Arrow` is `Strong` `Category`
Instance details Defined in Data.Profunctor.Strong Methods first' :: WrappedArrow p a b -> WrappedArrow p (a, c) (b, c) Source # second' :: WrappedArrow p a b -> WrappedArrow p (c, a) (c, b) Source #
ArrowChoice p => Choice (WrappedArrow p) Source # |
Instance details Defined in Data.Profunctor.Choice Methods left' :: WrappedArrow p a b -> WrappedArrow p (Either a c) (Either b c) Source # right' :: WrappedArrow p a b -> WrappedArrow p (Either c a) (Either c b) Source #
Category p => Category (WrappedArrow p :: Type -> Type -> Type) Source # |
Instance details Defined in Data.Profunctor.Types Methods id :: WrappedArrow p a a Source # (.) :: WrappedArrow p b c -> WrappedArrow p a b -> WrappedArrow p a c Source #

newtype Forget r a b Source #

Constructors

Forget |

Fields

- runForget :: a -> r

Instances

Profunctor (Forget r) Source # |
Instance details Defined in Data.Profunctor.Types Methods dimap :: (a -> b) -> (c -> d) -> Forget r b c -> Forget r a d Source # lmap :: (a -> b) -> Forget r b c -> Forget r a c Source # rmap :: (b -> c) -> Forget r a b -> Forget r a c Source # (#.) :: Coercible c b => q b c -> Forget r a b -> Forget r a c Source # (.#) :: Coercible b a => Forget r b c -> q a b -> Forget r a c Source #
Strong (Forget r) Source # |
Instance details Defined in Data.Profunctor.Strong Methods first' :: Forget r a b -> Forget r (a, c) (b, c) Source # second' :: Forget r a b -> Forget r (c, a) (c, b) Source #
Monoid r => Choice (Forget r) Source # |
Instance details Defined in Data.Profunctor.Choice Methods left' :: Forget r a b -> Forget r (Either a c) (Either b c) Source # right' :: Forget r a b -> Forget r (Either c a) (Either c b) Source #
Monoid m => Traversing (Forget m) Source # |
Instance details Defined in Data.Profunctor.Traversing Methods traverse' :: Traversable f => Forget m a b -> Forget m (f a) (f b) Source # wander :: (forall (f :: Type -> Type). Applicative f => (a -> f b) -> s -> f t) -> Forget m a b -> Forget m s t Source #
Representable (Forget r) Source # |
Instance details Defined in Data.Profunctor.Rep Associated Types type Rep (Forget r) :: Type -> Type Source # Methods tabulate :: (d -> Rep (Forget r) c) -> Forget r d c Source #
Sieve (Forget r) (Const r :: Type -> Type) Source # |
Instance details Defined in Data.Profunctor.Sieve Methods sieve :: Forget r a b -> a -> Const r b Source #
Functor (Forget r a) Source # |
Instance details Defined in Data.Profunctor.Types Methods fmap :: (a0 -> b) -> Forget r a a0 -> Forget r a b Source # (<$) :: a0 -> Forget r a b -> Forget r a a0 Source #
Foldable (Forget r a) Source # |

Instance details

Defined in Data.Profunctor.Types

Methods

fold :: Monoid m => Forget r a m -> m Source #

foldMap :: Monoid m => (a0 -> m) -> Forget r a a0 -> m Source #

foldr :: (a0 -> b -> b) -> b -> Forget r a a0 -> b Source #

foldr' :: (a0 -> b -> b) -> b -> Forget r a a0 -> b Source #

foldl :: (b -> a0 -> b) -> b -> Forget r a a0 -> b Source #

foldl' :: (b -> a0 -> b) -> b -> Forget r a a0 -> b Source #

foldr1 :: (a0 -> a0 -> a0) -> Forget r a a0 -> a0 Source #

foldl1 :: (a0 -> a0 -> a0) -> Forget r a a0 -> a0 Source #

toList :: Forget r a a0 -> [a0] Source #

null :: Forget r a a0 -> Bool Source #

length :: Forget r a a0 -> Int Source #

elem :: Eq a0 => a0 -> Forget r a a0 -> Bool Source #

maximum :: Ord a0 => Forget r a a0 -> a0 Source #

minimum :: Ord a0 => Forget r a a0 -> a0 Source #

sum :: Num a0 => Forget r a a0 -> a0 Source #

product :: Num a0 => Forget r a a0 -> a0 Source #

Traversable (Forget r a) Source # |
Instance details Defined in Data.Profunctor.Types Methods traverse :: Applicative f => (a0 -> f b) -> Forget r a a0 -> f (Forget r a b) Source # sequenceA :: Applicative f => Forget r a (f a0) -> f (Forget r a a0) Source # mapM :: Monad m => (a0 -> m b) -> Forget r a a0 -> m (Forget r a b) Source # sequence :: Monad m => Forget r a (m a0) -> m (Forget r a a0) Source #
type Rep (Forget r) Source # |
Instance details Defined in Data.Profunctor.Rep type Rep (Forget r) = (Const r :: Type -> Type)

type (:->) p q = forall a b. p a b -> q a b infixr 0 Source #